//----- Register Files------------------------------------------------------
INDF           EQU       00h
TMR0           EQU       01h
PCL            EQU       02h
STATUS         EQU       03h
FSR            EQU       04h
PORTA          EQU       05h
PORTB          EQU       06h
//***********BANK0*****************
TCXCON         EQU       07h
PCON           EQU       08h
WUCON          EQU       09h
PCHBUF         EQU       0Ah
PDCON          EQU       0Bh
ODCON          EQU       0Ch
PHCON          EQU       0Dh
INTEN          EQU       0Eh
INTFLAG        EQU       0Fh

//***********BANK1*****************
E2PCON         EQU       07H
E2PADR         EQU       08H
E2PDIN         EQU       09H
E2PDATA        EQU       0AH

//***********BANK2*****************
TC0M           EQU       07h
TC0C           EQU       08h
TC0R           EQU       09h
TC1M           EQU       0Ah
TC1C           EQU       0Bh
TC1R           EQU       0Ch
TC2M           EQU       0Dh
TC2C           EQU       0Eh
TC2R           EQU       0Fh
                                                
//INDF 00h
#define         INDF7         INDF,7
#define         INDF6         INDF,6
#define         INDF5         INDF,5
#define         INDF4         INDF,4
#define         INDF3         INDF,3
#define         INDF2         INDF,2
#define         INDF1         INDF,1
#define         INDF0         INDF,0

//TMR0  01h
#define         TMR07         TMR0,7
#define         TMR06         TMR0,6
#define         TMR05         TMR0,5
#define         TMR04         TMR0,4
#define         TMR03         TMR0,3
#define         TMR02         TMR0,2
#define         TMR01         TMR0,1
#define         TMR00         TMR0,0

//PCL   02h
#define         PCL7          PCL,7
#define         PCL6          PCL,6
#define         PCL5          PCL,5
#define         PCL4          PCL,4
#define         PCL3          PCL,3
#define         PCL2          PCL,2
#define         PCL1          PCL,1
#define         PCL0          PCL,0

//STATUS   03h          
#define         RST           STATUS,7
#define         GP1           STATUS,6
#define         GP0           STATUS,5
#define         TO            STATUS,4
#define         PD            STATUS,3
#define         Z             STATUS,2
#define         DC            STATUS,1
#define         C             STATUS,0

//FSR    04h
#define         RP1           FSR,7
#define         RP0           FSR,6

//PORTA   05h 
#define         IOA3          PORTA,3
#define         IOA2          PORTA,2
#define         IOA1          PORTA,1
#define         IOA0          PORTA,0

//PORTB   06h
#define         IOB7          PORTB,7
#define         IOB6          PORTB,6
#define         IOB5          PORTB,5
#define         IOB4          PORTB,4
#define         IOB3          PORTB,3
#define         IOB2          PORTB,2
#define         IOB1          PORTB,1
#define         IOB0          PORTB,0

//***********BANK0*****************
//TCXCON   07h
#define         TC10EN        TCXCON,3
#define         PWM1INV       TCXCON,2
#define         TC20EN        TCXCON,1
#define         PWM2INV       TCXCON,0

//PCON     08h   
#define         WDTE          PCON,7
#define         EIS           PCON,6
#define         LVDTE         PCON,5
#define         LVDF          PCON,4
#define         LVDRB         PCON,3
#define         LVDSEL2       PCON,2
#define         LVDSEL1       PCON,1
#define         LVDSEL0       PCON,0

//WUCON    09h
#define         WUB7          WUCON,7
#define         WUB6          WUCON,6
#define         WUB5          WUCON,5
#define         WUB4          WUCON,4
#define         WUB3          WUCON,3
#define         WUB2          WUCON,2
#define         WUB1          WUCON,1
#define         WUB0          WUCON,0

//PCHBUF    0Ah 
#define         PCHBUF0       PCHBUF,0
#define         PCHBUF1       PCHBUF,1

//PDCON     0Bh
#define         PDB2          PDCON,6
#define         PDB1          PDCON,5
#define         PDB0          PDCON,4
#define         PDA3          PDCON,3
#define         PDA2          PDCON,2
#define         PDA1          PDCON,1
#define         PDA0          PDCON,0

//ODCON     0Ch
#define         ODB7          ODCON,7                     
#define         ODB6          ODCON,6
#define         ODB5          ODCON,5
#define         ODB4          ODCON,4
#define         ODB2          ODCON,2
#define         ODB1          ODCON,1
#define         ODB0          ODCON,0

//PHCON     0Dh
#define         PHB7          PHCON,7
#define         PHB6          PHCON,6
#define         PHB5          PHCON,5
#define         PHB4          PHCON,4
#define         PHB2          PHCON,2
#define         PHB1          PHCON,1
#define         PHB0          PHCON,0

//INTEN     0Eh
#define         GIE           INTEN,7
#define         TC2IE         INTEN,5
#define         TC1IE         INTEN,4
#define         TC0IE         INTEN,3
#define         INTIE         INTEN,2
#define         PBIE          INTEN,1
#define         T0IE          INTEN,0

//INTFLAG   0Fh 
#define         TC2IF         INTFLAG,5
#define         TC1IF         INTFLAG,4
#define         TC0IF         INTFLAG,3
#define         INTIF         INTFLAG,2
#define         PBIF          INTFLAG,1
#define         T0IF          INTFLAG,0

//***********BANK1*****************
//E2PCON    07h 
#define         E2PRD          E2PCON,4
#define         E2PCER         E2PCON,3
#define         E2PSER         E2PCON,2
#define         E2PBER         E2PCON,1
#define         E2PWR          E2PCON,0

//E2PADR    08h
#define         E2PADR7        E2PADR,7
#define         E2PADR6        E2PADR,6
#define         E2PADR5        E2PADR,5
#define         E2PADR4        E2PADR,4
#define         E2PADR3        E2PADR,3
#define         E2PADR2        E2PADR,2
#define         E2PADR1        E2PADR,1
#define         E2PADR0        E2PADR,0

//E2PDIN    09h
#define         E2PDIN7        E2PDIN,7
#define         E2PDIN6        E2PDIN,6
#define         E2PDIN5        E2PDIN,5
#define         E2PDIN4        E2PDIN,4
#define         E2PDIN3        E2PDIN,3
#define         E2PDIN2        E2PDIN,2
#define         E2PDIN1        E2PDIN,1
#define         E2PDIN0        E2PDIN,0

//E2PDATA   0Ah
#define         E2PDA7         E2PDATA,7
#define         E2PDA6         E2PDATA,6
#define         E2PDA5         E2PDATA,5
#define         E2PDA4         E2PDATA,4
#define         E2PDA3         E2PDATA,3
#define         E2PDA2         E2PDATA,2
#define         E2PDA1         E2PDATA,1
#define         E2PDA0         E2PDATA,0

//***********BANK2*****************
//TC0M   07h
#define         TC0EN          TC0M,7
#define         TC0PS2         TC0M,6
#define         TC0PS1         TC0M,5
#define         TC0PS0         TC0M,4
#define         TC0CKS         TC0M,3
#define         ALOAD0         TC0M,2
#define         TC0OUT         TC0M,1
#define         PWM0EN         TC0M,0

//TC0C   08h
#define         TC0C7          TC0C,7
#define         TC0C6          TC0C,6
#define         TC0C5          TC0C,5
#define         TC0C4          TC0C,4
#define         TC0C3          TC0C,3
#define         TC0C2          TC0C,2
#define         TC0C1          TC0C,1
#define         TC0C0          TC0C,0

//TC0R   09h
#define         TC0R7          TC0R,7
#define         TC0R6          TC0R,6
#define         TC0R5          TC0R,5
#define         TC0R4          TC0R,4
#define         TC0R3          TC0R,3
#define         TC0R2          TC0R,2
#define         TC0R1          TC0R,1
#define         TC0R0          TC0R,0

//TC1M   0Ah
#define         TC1EN          TC1M,7
#define         TC1PS2         TC1M,6
#define         TC1PS1         TC1M,5
#define         TC1PS0         TC1M,4
#define         TC1CKS         TC1M,3
#define         ALOAD1         TC1M,2
#define         TC1OUT         TC1M,1
#define         PWM1EN         TC1M,0

//TC1C   0Bh
#define         TC1C7          TC1C,7
#define         TC1C6          TC1C,6
#define         TC1C5          TC1C,5
#define         TC1C4          TC1C,4
#define         TC1C3          TC1C,3
#define         TC1C2          TC1C,2
#define         TC1C1          TC1C,1
#define         TC1C0          TC1C,0

//TC1R   0Ch
#define         TC1R7          TC1R,7
#define         TC1R6          TC1R,6
#define         TC1R5          TC1R,5
#define         TC1R4          TC1R,4
#define         TC1R3          TC1R,3
#define         TC1R2          TC1R,2
#define         TC1R1          TC1R,1
#define         TC1R0          TC1R,0

//TC1M   0Dh
#define         TC2EN          TC2M,7
#define         TC2PS2         TC2M,6
#define         TC2PS1         TC2M,5
#define         TC2PS0         TC2M,4
#define         TC2CKS         TC2M,3
#define         ALOAD2         TC2M,2
#define         TC2OUT         TC2M,1
#define         PWM2EN         TC2M,0

//TC1C   0Eh
#define         TC2C7          TC2C,7
#define         TC2C6          TC2C,6
#define         TC2C5          TC2C,5
#define         TC2C4          TC2C,4
#define         TC2C3          TC2C,3
#define         TC2C2          TC2C,2
#define         TC2C1          TC2C,1
#define         TC2C0          TC2C,0

//TC1R   0Fh
#define         TC2R7          TC2R,7
#define         TC2R6          TC2R,6
#define         TC2R5          TC2R,5
#define         TC2R4          TC2R,4
#define         TC2R3          TC2R,3
#define         TC2R2          TC2R,2
#define         TC2R1          TC2R,1
#define         TC2R0          TC2R,0

//----------FC701 EEPROM궨--------------------
//#define  EEPROM_ADDRESS     0X3F    //RAM3FΪַĴ
//#define  EEPROM_WRITEDATA   0X3E    //RAM3EΪݼĴ
//#define  EEPROM_READDATA    0X3D    //RAM3EΪݼĴ

//----------BYTEд--------------------------------
//ʱԼ1ms    д֮ǰȲõַ
//ADDRESS ҪдĵַַΧ0~FF
//DATA    ҪдݣݷΧ0~FF
//      Եַ18HдֵAAH 
//            MOVIA        18H
//            MOVAR       EEPROM_ADDRESS       //дַ
//            MOVIA        AAH
//            MOVAR       EEPROM_WRITEDATA     //д
//            E2PROM_BYTE_WRITE    EEPROM_ADDRESS,EEPROM_WRITEDATA

/*E2PROM_BYTE_WRITE  MACRO  ADDRESS,DATA
BSR   RP0                   //bank1
MOVR  ADDRESS,0
MOVAR E2PADR                //дַ
MOVR  DATA,0
MOVAR E2PDIN                //д
BSR   E2PWR                 //дʹ1
BTRSC E2PWR
GOTO  $-1                    //ȴдʹΪ0E2PWRΪ0ʾд
BCR   RP0                   //bank0
E2PROM_BYTE_WRITE  ENDM */ 
//------------------------------------------------

//----------BYTE--------------------------------
//ADDRESS ҪдĵַַΧ0~FF
//EEPROM_READDATA 
//      ַ18Hе
//            MOVIA        18H
//            MOVAR       EEPROM_ADDRESS        //дַ
//            E2PROM_BYTE_READ   EEPROM_ADDRESS //ݶEEPROM_READDATA

/*E2PROM_BYTE_READ  MACRO  ADDRESS
BSR   RP0                  //bank1
MOVR  ADDRESS,0
MOVAR E2PADR               //дַ
//BSR   E2PRD
MOVR  E2PDATA,0            //ȡE2PDATA
MOVAR EEPROM_READDATA
BCR   RP0                  //bank0
E2PROM_BYTE_READ  ENDM*/
//-----------------------------------------------

//----------BYTE--------------------------------
//ʱԼ100ms
//ADDRESS ҪֲĵַַΧ0~FF
//      ַ18Hе
//            MOVIA        18H
//            MOVAR       EEPROM_ADDRESS         //дַ
//            E2PROM_BYTE_ERASE   EEPROM_ADDRESS //ַ18Hе

/*E2PROM_BYTE_ERASE  MACRO  ADDRESS
BSR   RP0                 //bank1
MOVR  ADDRESS,0
MOVAR E2PADR              //дַ
BSR   E2PBER              //ֲʹ
BTRSC E2PBER              //E2PBER־λ
goto  $-1                 //ȴֲʹΪ0E2PBERΪ0ʾֲ
BCR   RP0                 //bank0
E2PROM_BYTE_ERASE  ENDM */ 
//------------------------------------------------

//------------------------------------------
//ʱԼ100ms     һ16ַ
#define SECTOR_0    0      //SECTOR 0
#define SECTOR_1    16     //SECTOR 1
#define SECTOR_2    32     //SECTOR 2
#define SECTOR_3    48     //SECTOR 3
#define SECTOR_4    64     //SECTOR 4
#define SECTOR_5    80     //SECTOR 5
#define SECTOR_6    96     //SECTOR 6
#define SECTOR_7    112    //SECTOR 7
#define SECTOR_8    128    //SECTOR 8
#define SECTOR_9    144    //SECTOR 9
#define SECTOR_10   160    //SECTOR 10
#define SECTOR_11   176    //SECTOR 11
#define SECTOR_12   192    //SECTOR 12
#define SECTOR_13   208    //SECTOR 13
#define SECTOR_14   224    //SECTOR 14
#define SECTOR_15   240    //SECTOR 15

//SECTOR  Ҫ16SECTORÿSECTOR16ַ
//      6HӦĵַΪ96~111
//            MOVIA        SECTOR_6
//            MOVAR       EEPROM_ADDRESS         //дַ
//            E2PROM_BYTE_ERASE   EEPROM_ADDRESS //6H

/*E2PROM_SECTOR_ERASE  MACRO  SECTOR
BSR   RP0                //bank1
MOVR  SECTOR,0
MOVAR E2PADR             //дַ
BSR   E2PSER             //ʹ
BTRSC E2PSER             //ȴʹΪ0E2PSERΪ0ʾ
BCR   RP0                //bank0
E2PROM_SECTOR_ERASE  ENDM  */
//------------------------------------------------

//----------Ƭ--------------------------------
//ʱԼ100ms     еַв
//
//E2PROM_CHIPERASE    //ֱӵøó򼴲еַ

/*E2PROM_CHIPERASE     MACRO   
BSR   RP0               //ѡbank1
BSR   E2PCER            //Ƭʹ
BTRSC E2PCER            //ȴƬʹΪ0E2PSERΪ0ʾƬ
GOTO  $-1               //־λδ0ؼ
BCR   RP0
E2PROM_CHIPERASE     ENDM  */       
//------------------------------------------------

//----------BYTE+BYTEд-------------------------
//ʱԼ101ms
//ADDRESS Ҫд/ĵַַΧ0~FF
//DATA    ҪдݣݷΧ0~FF
//      Եַ18HдֵAAH 
//            MOVIA       18H
//            MOVAR       EEPROM_ADDRESS       //дַ
//            MOVIA       AAH
//            MOVAR       EEPROM_WRITEDATA     //д
//            E2PROM_BYTE_ERASE_WRITE    EEPROM_ADDRESS,EEPROM_WRITEDATA

/*E2PROM_BYTE_ERASE_WRITE  MACRO  ADDRESS,DATA
BSR   RP0                 //bank1
MOVR  ADDRESS,0
MOVAR E2PADR              //дַ
BSR   E2PBER              //ֲʹ
BTRSC E2PBER              //E2PBER־λ
goto  $-1                 //ȴֲʹΪ0E2PBERΪ0ʾֲ
MOVR  DATA,0
MOVAR E2PDIN                //д
BSR   E2PWR                 //дʹ1
BTRSC E2PWR
GOTO  $-1                    //ȴдʹΪ0E2PWRΪ0ʾд
BCR   RP0                 //bank0
E2PROM_BYTE_ERASE_WRITE  ENDM */                             
//------------------------------------------------


