;;--------------- FILE INCLUDE ---------------------------------------------
;;--------------------------------------------------------------------------
#include   "FC703.ASH"
#define    DUTY_10            10
#define    DUTY_50            13
#define    DUTY_75            25 

#define    DUTY_100           32  

#define    R         1
#define    A         0

#define    P_LED_R            PORTB,1
#define    P_LED_G            PORTB,2
#define    P_LED_B            PORTB,0

#define    P_IR               PORTB,3
//#define    P_SONG             PORTB,0

#define    bit260us           FLAG_BIT,0
#define    bit1ms             FLAG_BIT,1
#define    bit10ms            FLAG_BIT,2
#define    bit5ms             FLAG_BIT,3
#define    F_SLEEP            FLAG_BIT,4
#define    bitIrOk            FLAG_BIT,5
#define    bit130us           FLAG_BIT,6

#define    bitRedPwm          FLAG_LED,0
#define    bitGreenPwm        FLAG_LED,1
#define    bitBluePwm         FLAG_LED,2
#define    F_IR               FLAG_LED,3
#define    bitFlashLock       FLAG_LED,4
#define    bitWriteEnable     FLAG_LED,5
#define    F_J_D              FLAG_LED,6

#define    F_IR_LONG          FLAG_IR_L,0
#define    F_IR_BRIGHT        FLAG_IR_L,1
#define    F_IR_SPEED         FLAG_IR_L,2

;;==========================================================
;; ңֵ
;;==========================================================
#define    C_CUST_L           0x00            ;;ͻ
#define    C_CUST_H           0xEF
#define    C_INC              0x00            ;;
#define    C_DEC              0x01
#define    C_OFF              0x02            ;;
#define    C_ON               0x03 
#define    C_RED              0x04
#define    C_GREEN            0x05
#define    C_BLUE             0x06
#define    C_WHITE            0x07
#define    C_R1               0x08
#define    C_G1               0x09
#define    C_B1               0x0A
#define    C_FLASH            0x0B
#define    C_R2               0x0C
#define    C_G2               0x0D
#define    C_B2               0x0E
#define    C_STROBE           0x0F
#define    C_R3               0x10
#define    C_G3               0x11
#define    C_B3               0x12
#define    C_FADE             0x13
#define    C_R4               0x14
#define    C_G4               0x15
#define    C_B4               0x16
#define    C_SMOOTH           0x17
;;==========================================================
;; USE RAM EQUISTER ( 10H - 3FH )
;;==========================================================
R10                  REG     010H
R11                  REG     011H
CHECKSUM             REG     012H
u8IrValue            REG     013H
u8bright             REG     014H
U8PTR_SAT            REG     015H
U8PTR_END            REG     016H
u81ms                REG     017H
u85ms                REG     018H
u810ms              REG     019H
u8BlueDuty           REG     01AH
u8BlueDutyTmp        REG     01BH
u8tmp                REG     01CH
FLAG_IR_L             REG     01DH
u8count1             REG     01EH
u8count2             REG     01FH
u8brightTmp          REG     020H
u8AdjCount           REG     021H
u8260us              REG     022H
u8ptr                REG     023H
u8step               REG     024H
u8statusBak          REG     025H
u8y                  REG     026H
u8count2Tmp          REG     027H
u8pwm                REG     028H
u8RedDuty            REG     029H
u8RedDutyTmp         REG     02AH
u8GreenDuty          REG     02BH   
u8GreenDutyTmp       REG     02CH
u8count1Tmp          REG     02DH
u8cnt                REG     02EH
u8irStep             REG     02FH
u8irDataBit          REG     030H
u8DataH              REG     031H
u8DataL              REG     032H
u8CustH              REG     033H
u8CustL              REG     034H
u8realse             REG     035H
u8Twinkle            REG     036H
FSR_PROTECT          REG     037H
u8status             REG     038H
ACC_PROTECT          REG     039H
FLAG_LED             REG     03AH
FLAG_BIT             REG     03BH
STATUS_PROTECT       REG     03CH
EEPROM_ADDRESS       REG     03DH
EEPROM_WRITEDATA     REG     03EH
EEPROM_READDATA      REG     03FH

;;==========================================================
;;
;;==========================================================
        ORG     000H
        GOTO    START
        ORG     008H
        GOTO    HD_INTERRUPT_ENTER
      
tableRed:   
        MOVR    u8status,A  
        ADDAR   PCL,R  
        RETIA   0           ;;OFF     0   ػ      
        RETIA   DUTY_100    ;;        1   R
        RETIA   0           ;;        2   G
        RETIA   0           ;;        3   B
        RETIA   DUTY_100    ;;        4   WHITE 
        
        RETIA   DUTY_100    ;;        5   R1
        RETIA   0           ;;        6   G1
        RETIA   DUTY_10     ;;        7   B1
        NOP                 ;;        8
        RETIA   DUTY_100    ;;        9   R2
        RETIA   0           ;;        10  G2
        RETIA   DUTY_50     ;;        11  B2
        NOP                 ;;        12
        RETIA   DUTY_100    ;;        13  R3
        RETIA   0           ;;        14  G3
        RETIA   DUTY_75     ;;        15  B3
        NOP                 ;;        16
        RETIA   DUTY_100    ;;        17  R4
        RETIA   0           ;;        18  G4
        RETIA   DUTY_100    ;;        19  B4
                
tableGreen:
        MOVR    u8status,A
        ADDAR   PCL,R   
        RETIA   0           ;;OFF     0  ػ       
        RETIA   0           ;;        1  R
        RETIA   DUTY_100    ;;        2  G
        RETIA   0           ;;        3  B
        RETIA   DUTY_100    ;;        4  WHITE
    
        RETIA   DUTY_10     ;;        5  R1
        RETIA   DUTY_100    ;;        6  G1 
        RETIA   0           ;;        7  B1
        NOP                 ;;        8
        RETIA   DUTY_50     ;;        9   R2
        RETIA   DUTY_100    ;;        10  G2
        RETIA   0           ;;        11  B2
        NOP                 ;;        12
        RETIA   DUTY_75    ;;         13  R3
        RETIA   DUTY_75     ;;        14  G3
        RETIA   0           ;;        15  B3
        NOP                 ;;        16
        RETIA   DUTY_100    ;;        17  R4
        RETIA   DUTY_50     ;;        18  G4
        RETIA   0           ;;        19  B4
tableBlue:
        MOVR    u8status,A  
        ADDAR   PCL,R             
        RETIA   0           ;;OFF     0  ػ       
        RETIA   0           ;;        1  R0
        RETIA   0           ;;        2  R1
        RETIA   DUTY_100    ;;        3  R2 
        RETIA   DUTY_100    ;;        4  WHITE

        RETIA   0           ;;        5  R1
        RETIA   DUTY_50     ;;        6  G1
        RETIA   DUTY_100    ;;        7  B1
        NOP                 ;;        8
        RETIA   0           ;;        9   R2
        RETIA   DUTY_75     ;;        10  G2
        RETIA   DUTY_100    ;;        11  B2
        NOP                 ;;        12
        RETIA   0           ;;        13  R3
        RETIA   DUTY_100    ;;        14  G3
        RETIA   DUTY_100    ;;        15  B3
        NOP                 ;;        16
        RETIA   0           ;;        17  R4
        RETIA   DUTY_100    ;;        18  G4
        RETIA   DUTY_100    ;;        19  B4
        
tableFade1:
        ADDAR   PCL,R
        RETIA   00000010B   ;;0
        RETIA   00001000B   ;;1
        RETIA   00100000B   ;;2
        
        RETIA   00001010B   ;;3
        RETIA   00100010B   ;;4
        RETIA   00101000B   ;;5
        RETIA   00101010B   ;;6 
        
        
        
        RETIA   00010011B   ;;7
        RETIA   00001101B   ;;8
        RETIA   00110100B   ;;9  
        
        
        RETIA   00101110B   ;;10        
        RETIA   00010110B   ;;11        
        RETIA   00001101B   ;;12 
        RETIA   00110100B   ;;13        
        RETIA   00011111B   ;;14               
        RETIA   00111001B   ;;15 
        RETIA   00100111B   ;;16 
         
        
        



                
tableStatus:
        ADDAR   PCL,R
        RETIA   0     ;;0      
        RETIA   0     ;;1   
        RETIA   0     ;;2   
        RETIA   0     ;;3  
        RETIA   1     ;;4
        RETIA   2     ;;5        
        RETIA   3     ;;6
        RETIA   4     ;;7      
        RETIA   5     ;;8   
        RETIA   6     ;;9   
        RETIA   7     ;;10  
        RETIA   8     ;;11  
        RETIA   9     ;;12
        RETIA   10    ;;13        
        RETIA   11    ;;14  
        RETIA   12    ;;15  
        RETIA   13    ;;16        
        RETIA   14    ;;17  
        RETIA   15    ;;18        
        RETIA   16    ;;19
        RETIA   17    ;;20        
        RETIA   18    ;;21
        RETIA   19    ;;22        
        RETIA   20    ;;23
IR_SERVICE:        
        BTRSS   bitIrOk
        RETURN
        BCR     bitIrOk
        
        MOVR    u8IrValue,A
        SUBIA   0x17  
        BTRSS   C 
        RETURN  ;;0нλ
        
        MOVR    u8IrValue,A  
        ADDAR   PCL,R  
        GOTO    INC_ENTERN    ;;0
        GOTO    DEC_ENTERN    ;;1
        GOTO    OFF_ENTERN    ;;2
        GOTO    ON_ENTERN     ;;3 
        
        GOTO    RED_ENTERN    ;;4     1
        GOTO    GREEN_ENTERN  ;;5     2
        GOTO    BLUE_ENTERN   ;;6
        GOTO    WHITE_ENTERN  ;;7
        
        GOTO    R1_ENTERN     ;;8
        GOTO    G1_ENTERN     ;;9
        GOTO    B1_ENTERN     ;;0A   10
        
        GOTO    FLASH_ENTERN     ;;0B   11
        GOTO    R2_ENTERN        ;;0C   12
        GOTO    G2_ENTERN        ;;0D   13
        GOTO    B2_ENTERN        ;;0E   14
        GOTO    STROBE_ENTERN    ;;0F   15
        GOTO    R3_ENTERN        ;;10   16
        GOTO    G3_ENTERN        ;;11   17
        GOTO    B3_ENTERN        ;;12   18
        GOTO    FADE_ENTERN      ;;13   19       
        GOTO    R4_ENTERN        ;;14   20
        GOTO    G4_ENTERN        ;;15   21
        GOTO    B4_ENTERN        ;;16   22
        GOTO    SMOOTH_ENTERN    ;;17   23     
INC_ENTERN:
        ;;жF_J_DǷ1
        BTRSC    F_SLEEP
        RETURN
        BTRSC   F_J_D
        GOTO    DONGTAI_INC
        GOTO    JINTAI_INC

JINTAI_INC:
        MOVIA   33
        SUBAR   u8bright,A
        BTRSS   C  
        GOTO    $+4
        MOVIA   32
        MOVAR   u8bright
        RETURN
        INCR    u8bright,R
        BTRSS   F_IR_LONG
        CALL    WRITE_BRIGHT_TO_EE
        BSR     F_IR_BRIGHT
        RETURN

DONGTAI_INC:   
        MOVIA   2
        SUBAR   u8count2Tmp,A
        BTRSC   C 
        GOTO    $+4
        MOVIA   1
        MOVAR   u8count2Tmp                //45
        RETURN   
        DECR     u8count2Tmp,R
        BTRSS   F_IR_LONG
        CALL    WRITE_SPEED_TO_EE
        BSR     F_IR_SPEED
        RETURN 
        /*MOVIA   226
        SUBAR   u8count2Tmp,A
        BTRSS   C 
        GOTO    $+4
        MOVIA   225
        MOVAR   u8count2Tmp                //45
        RETURN   
        MOVIA   5
        ADDAR   u8count2Tmp,R   
        RETURN */
              
        
DEC_ENTERN: 
        BTRSC    F_SLEEP
        RETURN       
        BTRSC   F_J_D
        GOTO    DONGTAI_DEC
        GOTO    JINTAI_DEC

JINTAI_DEC:
        MOVIA   2
        SUBAR   u8bright,A
        BTRSC   C
        GOTO    $+4
        MOVIA   1
        MOVAR   u8bright
        RETURN
        DECR    u8bright,R
        BTRSS   F_IR_LONG
        CALL    WRITE_BRIGHT_TO_EE
        BSR     F_IR_BRIGHT
        RETURN

DONGTAI_DEC:  
        MOVIA   46
        SUBAR   u8count2Tmp,A
        BTRSS   C 
        GOTO    $+4
        MOVIA   45
        MOVAR   u8count2Tmp                //45
        RETURN   
        INCR    u8count2Tmp,R
        BTRSS   F_IR_LONG
        CALL    WRITE_SPEED_TO_EE
        BSR     F_IR_SPEED
        RETURN
        /*MOVIA   6
        SUBAR   u8count2Tmp,A
        BTRSC   C
        GOTO    $+4      
        MOVIA   5
        MOVAR   u8count2Tmp
        RETURN 
        MOVIA   5
        SUBAR   u8count2Tmp,R
        RETURN*/   
           
    

  
OFF_ENTERN:
        /*MOVR    u8status,A
        SUBIA   16
        BTRSC   C
        GOTO    $+3       ;;1 ޽λ
        CLRR    u8status  ;;0 нλ
        RETURN
        MOVR    u8status,A
        MOVAR   u8statusBak
        CLRR    u8status        
        RETURN */
       // MOVIA   20
        //MOVAR   u8status 
        BSR    F_SLEEP 
        CALL   ALL_LED_DUTY_CLEAN
        RETURN
        
ON_ENTERN:        
        BCR    F_SLEEP
        RETURN     



                  
RED_ENTERN:
GREEN_ENTERN:
BLUE_ENTERN:
WHITE_ENTERN:
R1_ENTERN:
G1_ENTERN:
B1_ENTERN:
R2_ENTERN: 
G2_ENTERN: 
B2_ENTERN:
R3_ENTERN: 
G3_ENTERN: 
B3_ENTERN:
R4_ENTERN: 
G4_ENTERN: 
B4_ENTERN: 
     BTRSC    F_SLEEP
     RETURN
     GOTO  STATUS_FZ
     


FLASH_ENTERN: 
SMOOTH_ENTERN:
     BTRSC    F_SLEEP
     RETURN
     BCR  bitFlashLock
     GOTO  STATUS_FZ
STROBE_ENTERN:
FADE_ENTERN: 
     BTRSC    F_SLEEP
     RETURN
     BCR  bitFlashLock
     MOVIA   32
     MOVAR   u8brightTmp
     
STATUS_FZ:
        MOVR    u8IrValue,A
        CALL    tableStatus
        MOVAR   u8status
        MOVAR   u8statusBak 
        CALL    WRTIE_U8STATUS_TO_EE
        RETURN        
;;==========================================================
;;    MAIN SEGMENT
;;==========================================================
START:
        CALL    INIT_SYSTEM
        CLRR    FLAG_BIT
        CLRR    FLAG_LED
        CLRR    FLAG_IR_L
        CLRR    u8ptr
        CLRR    u8irStep
        MOVIA   2
        MOVAR   u8260us
        MOVIA   42
        MOVAR   u85ms 
        CALL    ALL_LED_DUTY_CLEAN
        
        CALL    READ_4BYTES
        
        MOVR    CHECKSUM,A
        XORIA   0xAA
        BTRSS   Z
        GOTO    POWER_UP_1ST
POWER_UP_2ND:
        GOTO    MAIN_LOOPS
POWER_UP_1ST:
        MOVIA   32
        MOVAR   u8bright 
        MOVIA   12
        MOVAR   u8count2Tmp
     
        MOVIA   8
        MOVAR   u8statusBak
        MOVAR   u8status

       ;; MOVIA   00H
        CLRR    EEPROM_ADDRESS
        MOVIA   0xAA
        MOVAR   EEPROM_WRITEDATA
        CALl    WAIT_FOR_WRITE


        CALL    WRTIE_U8STATUS_TO_EE
        CALl    WAIT_FOR_WRITE


        CALL    WRITE_BRIGHT_TO_EE
        CALl    WAIT_FOR_WRITE

        CALL    WRITE_SPEED_TO_EE
        CALl    WAIT_FOR_WRITE

               
MAIN_LOOPS: 
        CALL    T0_ENABLE
MAIN_LOOP:
        BTRSS   bit130us
        GOTO    bit130us_exit
        BCR     bit130us
        CALL    PWM_CTR
bit130us_exit:
        BTRSS   bit260us
        GOTO    bit260us_exit
        BCR     bit260us
        CALL    SCAN_IR         ;;ɨ
        BTRSC   F_IR_LONG
        GOTO    bit260us_exit
        BTRSS   F_IR_BRIGHT
        GOTO    $+4
        BCR     F_IR_BRIGHT
        CALL    WRITE_BRIGHT_TO_EE
        GOTO    bit260us_exit
        BTRSS   F_IR_SPEED
        GOTO    bit260us_exit
        BCR     F_IR_SPEED
        CALL    WRITE_SPEED_TO_EE
bit260us_exit:
        BTRSS   bit5ms
        GOTO    bit5ms_exit
        BCR     bit5ms
        CALL    WRITE_1_BYTE
        CALL    IR_SERVICE      ;; 
        BTRSS   F_SLEEP
        CALL    LED_CTR
       // CALL    SLEEP_CTR       ;;˯߿
bit5ms_exit:   
        BTRSS   bit10ms
        GOTO    bit10ms_exit
        BCR     bit10ms
        
       
bit10ms_exit:  
  
 
        GOTO    MAIN_LOOP
     
  

;******************************************************************************************************
;*      :
;*      ܣɨ
;*  ˵    
;*  ڲ
;*  ڲ
;*      ڣ2020525
;*      ߣм
;******************************************************************************************************/
SCAN_IR:
        MOVIA   0x00
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT1

        BCR     F_IR_LONG
        BTRSC   P_IR
        RETURN
        CLRR    u8cnt
        MOVIA   0x02
        MOVAR   u8irStep
        RETURN
S_I_EXIT1:
        MOVIA   0x02
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT2

        INCR    u8cnt,R
        ;;͵ƽж
        BTRSS   P_IR
        GOTO    $+5
        CLRR    u8cnt     ;;⵽ߵƽ̽һ
        MOVIA   0x03
        MOVAR   u8irStep
        RETURN


        MOVR    u8cnt,A
        SUBIA   38
        BTRSS   C
        CLRR    u8irStep      ;;͵ƽʱ1ms,˳
        RETURN
S_I_EXIT2:
        MOVIA   0x03
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT3


        ;;ߵƽж
        INCR    u8cnt,R

        BTRSC   P_IR
        GOTO    $+6
        MOVIA   0x04
        MOVAR   u8irStep
        CLRR    u8cnt
        CLRR    u8irDataBit
        RETURN


        MOVR    u8cnt,A
        SUBIA   18
        BTRSS   C
        CLRR    u8irStep      ;;ߵƽʱ2.25ms,˳
        RETURN

S_I_EXIT3:
        MOVIA   0x04
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT4

        INCR    u8cnt,R
        ;;͵ƽж
        BTRSS   P_IR
        GOTO    $+5
        CLRR    u8cnt     ;;⵽ߵƽ̽һ
        MOVIA   0x05
        MOVAR   u8irStep 
        RETURN
     

        MOVR    u8cnt,A
        SUBIA   2
        BTRSS   C        
        CLRR    u8irStep      ;;͵ƽʱ1ms,˳
        RETURN
S_I_EXIT4: 
        MOVIA   0x05
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT5


        ;;ߵƽж
        INCR    u8cnt,R

        BTRSC   P_IR
        GOTO    $+4
        MOVIA   0x06
        MOVAR   u8irStep
        RETURN


        MOVR    u8cnt,A
        SUBIA   6
        BTRSS   C
        CLRR    u8irStep      ;;ߵƽʱ2.25ms,˳
        RETURN          

S_I_EXIT5: 
        MOVIA   0x06
        XORAR   u8irStep,A 
        BTRSS   Z
        GOTO    S_I_EXIT6
        
        MOVR    u8cnt,A 
        SUBIA   3
        BTRSC   C
        GOTO    $+3                 ;;u8cnt<=5                                    
        BSR     C                ;;u8cnt>5
        GOTO    $+2
        BCR     C
        RRR     u8DataH,R
        RRR     u8DataL,R
        RRR     u8CustH,R
        RRR     u8CustL,R

        INCR    u8irDataBit,R
        MOVR    u8irDataBit,A
        SUBIA   31
        BTRSS   C
        GOTO    $+5
        MOVIA   4
        MOVAR   u8irStep
        CLRR    u8cnt
        RETURN
        CLRR    u8cnt
        MOVIA   7
        MOVAR   u8irStep
        RETURN
S_I_EXIT6:
        MOVIA   0x07  
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT7
        
        CLRR    u8irStep
        
        MOVIA   C_CUST_L                 ;;ͻ
        XORAR   u8CustL,A
        BTRSS   Z
        RETURN

        MOVIA   C_CUST_H
        XORAR   u8CustH,A
        BTRSS   Z
        RETURN

        COMR    u8DataL,A
        XORAR   u8DataH,A
        BTRSC   Z
        GOTO    $+3
        CLRR    u8irStep
        RETURN
        BSR     bitIrOk               ;;OK
        MOVR    u8DataL,A
        MOVAR   u8IrValue
        MOVIA   0x08
        MOVAR   u8irStep
        CLRR    u8cnt
        RETURN

S_I_EXIT7:
        MOVIA   0x08
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT8

        INCR    u8cnt,R
        ;;͵ƽж
        BTRSS   P_IR
        GOTO    $+5
        CLRR    u8cnt     ;;⵽ߵƽ̽һ
        MOVIA   0x09
        MOVAR   u8irStep
        RETURN
        MOVR    u8cnt,A
        SUBIA   5
        BTRSS   C
        CLRR    u8irStep      ;;͵ƽʱ1ms,˳
        RETURN

S_I_EXIT8:
        MOVIA   0x09
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT9

        INCR    u8cnt,R
        ;;͵ƽж
        BTRSC   P_IR
        GOTO    $+9
        MOVR    u8cnt,A
        SUBIA   120
        BTRSC   C
        GOTO    $+5
        CLRR    u8cnt     ;;⵽ߵƽ̽һ
        MOVIA   0x10
        MOVAR   u8irStep
        RETURN
                  
        MOVR    u8cnt,A
        SUBIA   148
        BTRSS   C
        CLRR    u8irStep      ;;͵ƽʱ1ms,˳
        RETURN
        
S_I_EXIT9:
        MOVIA   0x10 
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT10

        INCR    u8cnt,R
        ;;͵ƽж
        BTRSS   P_IR
        GOTO    $+9
        MOVR    u8cnt,A
        SUBIA   25
        BTRSC   C
        GOTO    $+5
        CLRR    u8cnt     ;;⵽ߵƽ̽һ
        MOVIA   0x11
        MOVAR   u8irStep
        RETURN

        MOVR    u8cnt,A
        SUBIA   40
        BTRSS   C
        CLRR    u8irStep      ;;͵ƽʱ1ms,˳
        RETURN  

S_I_EXIT10:
        MOVIA   0x11
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT11

        INCR    u8cnt,R
        ;;͵ƽж
        BTRSC   P_IR
        GOTO    $+5
        CLRR    u8cnt     ;;⵽ߵƽ̽һ
        MOVIA   0x12
        MOVAR   u8irStep
        RETURN

        MOVR    u8cnt,A
        SUBIA   15
        BTRSS   C
        CLRR    u8irStep      ;;͵ƽʱ1ms,˳
        RETURN
S_I_EXIT11:
        MOVIA   0x12
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT12

        INCR    u8cnt,R
        ;;͵ƽж
        BTRSS   P_IR
        GOTO    $+5
        CLRR    u8cnt     ;;⵽ߵƽ̽һ
        MOVIA   0x13
        MOVAR   u8irStep
        RETURN

        MOVR    u8cnt,A
        SUBIA   5
        BTRSS   C
        CLRR    u8irStep      ;;͵ƽʱ1ms,˳
        RETURN

S_I_EXIT12:
        MOVIA   0x13
        XORAR   u8irStep,A
        BTRSS   Z
        RETURN

        INCR    u8cnt,R
        ;;͵ƽж
        BTRSS   F_IR
        GOTO    X2
        BTRSC   P_IR
        GOTO    X2
        MOVR    u8cnt,A
        SUBIA   130
        BTRSC   C
        GOTO    X2
        CLRR    u8cnt
        MOVIA   0X10
        MOVAR   u8irStep
        BCR     F_IR
       /* INCR    u8y,R
        MOVR    u8y,A
        XORIA   2
        BTRSS   Z
        GOTO    $+3
        CLRR    u8y */
        BSR     bitIrOk
        BSR     F_IR_LONG
        RETURN

       /* BTRSC   P_IR
        GOTO    $+5
        CLRR    u8cnt
        CLRR    u8irStep
        BSR     bitIrOk

        RETURN */
X2:
        MOVR    u8cnt,A
        SUBIA   170
        BTRSC   C
        RETURN
        CLRR    u8cnt
        BTRSC   F_IR
        GOTO    $+3
        BSR     F_IR
        RETURN
        BCR     F_IR
        CLRR    u8irStep
        RETURN
      /*  BTRSC   P_IR
        GOTO    IR_IS_H
        MOVIA   200
        MOVAR   u8realse
        BCR     bitRealse
        GOTO    CHECK_EXIT
IR_IS_H:
        DECRSZ  u8realse,R
        GOTO    CHECK_EXIT
        MOVIA   200
        MOVAR   u8realse
        BSR     bitRealse
CHECK_EXIT:

        MOVIA   0x00
        XORAR   u8irStep,A
        BTRSS   Z
        GOTO    S_I_EXIT1

        BTRSC   P_IR
        RETURN
        
        MOVIA   0x02
        MOVAR   u8irStep  
        CLRR    u8cnt
        CLRR    u8irDataBit    
        RETURN
S_I_EXIT1:  
        MOVIA   0x02  
        XORAR   u8irStep,A 
        BTRSS   Z
        GOTO    S_I_EXIT2   
        
        INCR    u8cnt,R  
        ;;͵ƽж
        BTRSS   P_IR
        GOTO    $+5  
        CLRR    u8cnt     ;;⵽ߵƽ̽һ
        MOVIA   0x03
        MOVAR   u8irStep 
        RETURN
     
        
        MOVR    u8cnt,A  
        SUBIA   3
        BTRSS   C 
        CLRR    u8irStep      ;;͵ƽʱ1ms,˳   
        RETURN
S_I_EXIT2: 
        MOVIA   0x03  
        XORAR   u8irStep,A 
        BTRSS   Z
        GOTO    S_I_EXIT3      
       
        
        ;;ߵƽж
        INCR    u8cnt,R  
     
        BTRSC   P_IR
        GOTO    $+4      
        MOVIA   0x04
        MOVAR   u8irStep 
        RETURN
     
        
        MOVR    u8cnt,A  
        SUBIA   6
        BTRSS   C 
        CLRR    u8irStep      ;;ߵƽʱ2.25ms,˳                   
        RETURN
S_I_EXIT3: 
        MOVIA   0x04  
        XORAR   u8irStep,A 
        BTRSS   Z
        GOTO    S_I_EXIT4      
        
        MOVR    u8cnt,A 
        SUBIA   4
        BTRSC   C
        GOTO    $+3                 ;;u8cnt<=5                                    
        BSR     C                ;;u8cnt>5  
        GOTO    $+2 
        BCR     C
        RRR     u8DataH,R
        RRR     u8DataL,R
        RRR     u8CustH,R
        RRR     u8CustL,R 
        
        INCR    u8irDataBit,R 
        MOVR    u8irDataBit,A
        SUBIA   31
        BTRSC   C
        GOTO    $+4
        MOVIA   5 
        MOVAR   u8irStep  
        RETURN  
        CLRR    u8cnt
        MOVIA   2 
        MOVAR   u8irStep               
        RETURN
S_I_EXIT4:
        MOVIA   0x05  
        XORAR   u8irStep,A 
        BTRSS   Z
        RETURN 
        
        CLRR    u8irStep      
        
        MOVIA   C_CUST_L                 ;;ͻ    
        XORAR   u8CustL,A
        BTRSS   Z
        RETURN
        
        MOVIA   C_CUST_H
        XORAR   u8CustH,A
        BTRSS   Z
        RETURN
        
        COMR    u8DataL,A
        XORAR   u8DataH,A           
        BTRSS   Z
        RETURN
        BSR     bitIrOk               ;;OK
        MOVR    u8DataL,A
        MOVAR   u8IrValue      
        RETURN   */
;******************************************************************************************************
;*      :
;*      ܣģPWM,ɵ
;*  ˵    
;*  ڲu8RedDuty,u8GreenDuty,u8BlueDuty,u8brightTmp
;*  ڲ: RGB
;*      ڣ202063
;*      ߣм
;******************************************************************************************************/
PWM_CTR:
        DECRSZ  u8pwm,R
        GOTO    PWM_KEEP_INTLP
PWM_INIT_INTLP:      
        MOVIA   DUTY_100
        MOVAR   u8pwm
          
        MOVR    u8RedDuty,A          ;;B0
        MOVAR   u8RedDutyTmp
        BTRSS   Z
        GOTO    $+3
        BCR     bitRedPwm
        GOTO    $+2
        BSR     bitRedPwm       
          
        MOVR    u8GreenDuty,A        ;;B1    
        MOVAR   u8GreenDutyTmp
        BTRSS   Z
        GOTO    $+3
        BCR     bitGreenPwm 
        GOTO    $+2
        BSR     bitGreenPwm    

        MOVR    u8BlueDuty,A         ;;B2    
        MOVAR   u8BlueDutyTmp
        BTRSS   Z
        GOTO    $+3
        BCR     bitBluePwm 
        GOTO    $+2
        BSR     bitBluePwm  
        
        GOTO    ADJ_BRIGHT
PWM_KEEP_INTLP:    
        DECRSZ  u8RedDutyTmp,R       ;;B0
        GOTO    $+2
        BCR     bitRedPwm

        DECRSZ  u8GreenDutyTmp,R     ;;B1
        GOTO    $+2
        BCR     bitGreenPwm 
        
        DECRSZ  u8BlueDutyTmp,R      ;;B1
        GOTO    $+2
        BCR     bitBluePwm        
        GOTO    ADJ_BRIGHT
ADJ_BRIGHT:
        INCR    u8AdjCount,R
        
        MOVIA   32                  ;;ǶپǼ    øһ
        SUBAR   u8AdjCount,A
        BTRSC   C          
        CLRR    u8AdjCount           ;;1 ޽λ        
    
        BTRSC   bitRedPwm
        BSR     P_LED_R   
        BTRSC   bitGreenPwm
        BSR     P_LED_G          
        BTRSC   bitBluePwm
        BSR     P_LED_B
                   
                      
        MOVR    u8AdjCount,A    ;;0~6    
        SUBAR   u8brightTmp,A   ;;0~6    //  ڵ
        BTRSS   C                   
        GOTO    $+8                   ;;0  нλ    u8AdjCount>u8brightTmp      
        BTRSS   bitRedPwm             ;;1  ޽λ    u8AdjCount <=u8brightTmp
        BCR     P_LED_R   
        BTRSS   bitGreenPwm
        BCR     P_LED_G          
        BTRSS   bitBluePwm
        BCR     P_LED_B    
        RETURN    
        CALL    ALL_LED_OFF
        RETURN        
        
ALL_LED_OFF:
        BCR     P_LED_R
        BCR     P_LED_G 
        BCR     P_LED_B    
        RETURN   
LED_R_ON:
        MOVIA   DUTY_100
        MOVAR   u8RedDuty 
        RETURN 
LED_R_OFF:
        ;;MOVIA   0
        ;;MOVAR   u8RedDuty
        CLRR    u8RedDuty
        RETURN    
LED_G_ON:     
        MOVIA   DUTY_100
        MOVAR   u8GreenDuty
        RETURN
LED_G_OFF:     
        ;;MOVIA   0
        ;;MOVAR   u8GreenDuty 
        CLRR    u8GreenDuty
        RETURN
LED_B_ON:     
        MOVIA   DUTY_100
        MOVAR   u8BlueDuty 
        RETURN 
LED_B_OFF:     
        ;;MOVIA   0
        ;;MOVAR   u8BlueDuty
        CLRR    u8BlueDuty
        RETURN
ALL_LED_DUTY_CLEAN:
        CLRR    u8RedDuty
        CLRR    u8GreenDuty
        CLRR    u8BlueDuty
        RETURN

;******************************************************************************************************
;*      :
;*      ܣFADEӳ
;*  ˵    
;*  ڲ
;*  ڲ
;*      ڣ202084
;*      ߣм
;****************************************************************************************************** 
FADE_:  
        //MOVIA   0X20
        //XORAR   PORTB,R  
        MOVR    u8ptr,A
        CALL    tableFade1
        MOVAR   u8tmp
        
        BTRSC   u8tmp,0         // =1˸   =0ǽ
        GOTO    $+6
        BTRSC   u8tmp,1         //=1
        CALL    LED_R_ON
        BTRSS   u8tmp,1         //=0
        CALL    LED_R_OFF
        GOTO    r_exit          
        
        BTRSC   u8tmp,1         //
        GOTO    $+4
        MOVR    u8count1,A      //
        MOVAR   u8RedDuty 
        GOTO    r_exit
        MOVR    u8count1,A      //
        SUBIA   DUTY_100
        MOVAR   u8RedDuty           
r_exit: 
        BTRSC   u8tmp,2
        GOTO    $+6
        BTRSC   u8tmp,3
        CALL    LED_G_ON
        BTRSS   u8tmp,3
        CALL    LED_G_OFF  
        GOTO    g_exit 
        
        BTRSC   u8tmp,3
        GOTO    $+4
        MOVR    u8count1,A
        MOVAR   u8GreenDuty 
        GOTO    g_exit
        MOVR    u8count1,A
        SUBIA   DUTY_100
        MOVAR   u8GreenDuty           
g_exit:   
        BTRSC   u8tmp,4
        GOTO    $+6
        BTRSC   u8tmp,5
        CALL    LED_B_ON
        BTRSS   u8tmp,5
        CALL    LED_B_OFF  
        GOTO    b_exit 
        
        BTRSC   u8tmp,5
        GOTO    $+4
        MOVR    u8count1,A
        MOVAR   u8BlueDuty 
        GOTO    b_exit
        MOVR    u8count1,A
        SUBIA   DUTY_100
        MOVAR   u8BlueDuty           
b_exit:  
             
        DECRSZ  u8count2,R
        RETURN  
        ;;MOVR    u8speed,A
        ;;CALL    tableFadeSpeed
        ;;MOVAR   u8count2  
        MOVR    u8count2Tmp,A          //ٶ
        MOVAR   u8count2    
        
        DECRSZ  u8count1,R             //ƽ
        RETURN 
        ;;MOVIA   DUTY_100
        ;;MOVAR   u8count1        
        MOVR    u8count1Tmp,A 
        MOVAR   u8count1     
        
        INCR    u8ptr,R
        MOVR    u8ptr,A
        SUBAR   U8PTR_END,A
        BTRSC   C
        RETURN
        MOVR    U8PTR_SAT,A
        MOVAR   u8ptr          ;; 0  нλ
        RETURN  
;******************************************************************************************************
;*      :
;*      ܣLEDƿ
;*  ˵    
;*  ڲ
;*  ڲ
;*      ڣ202063
;*      ߣм
;******************************************************************************************************
LED_CTR:
        MOVR    u8status,A
        XORIA   0
        BTRSC   Z
        RETURN
        
        MOVR    u8status,A
        XORIA   8
        BTRSC   Z
        GOTO    FLASH_EN
        
        
        MOVR    u8status,A
        XORIA   12
        BTRSC   Z
        GOTO    STROBE_EN
        
        MOVR    u8status,A
        XORIA   16
        BTRSC   Z
        GOTO    FADE_EN
        
        MOVR    u8status,A
        XORIA   20
        BTRSC   Z
        GOTO    SMOOTH_EN     

        BCR   F_J_D
        MOVR    u8bright,A 
        MOVAR   u8brightTmp        
        ;;̬ɫ                         
        CALL    tableRed
        MOVAR   u8RedDuty     
            
        CALL    tableGreen
        MOVAR   u8GreenDuty
           
        CALL    tableBlue
        MOVAR   u8BlueDuty    
        RETURN  
        
        
FLASH_EN:                         //˸
        BTRSC   bitFlashLock
        GOTO    FLASH_EN1
        BSR     bitFlashLock
        BSR     F_J_D
        CLRR    U8PTR_SAT
        CLRR    u8ptr
        MOVIA   2
        MOVAR   U8PTR_END
        MOVIA   5                 //㷨  εС24ms,5MSһγu8count2TmpٵС1  //ʱ5ms*u8count2Tmp*u8count1Tmp=25MS=24ms  ÿμӵ24ms
        MOVAR   u8count1Tmp       //˸Ļֵ
        MOVIA   1
        MOVAR   u8count1
        MOVAR   u8count2          
FLASH_EN1:         
        CALL    FADE_
        RETURN    

 
STROBE_EN:
        BTRSC   bitFlashLock
        GOTO    STROBE_EN1
        BSR     bitFlashLock
        BSR  F_J_D
        MOVIA   7
        MOVAR   U8PTR_SAT
        MOVAR   u8ptr
        MOVIA   9
        MOVAR   U8PTR_END
        MOVIA   32              //ֵ   㷨ǣ5ms*u8count2Tmp*u8count1Tmp=160    ÿμӵ160ms
        MOVAR   u8count1Tmp
        MOVAR   u8count1
        MOVIA   1
        MOVAR   u8count2 

STROBE_EN1:
        CALL    FADE_
        RETURN    

FADE_EN:
        BTRSC   bitFlashLock
        GOTO    FADE_EN1
        BSR     bitFlashLock
        BSR  F_J_D
        MOVIA   10
        MOVAR   U8PTR_SAT
        MOVAR   u8ptr
        MOVIA   16
        MOVAR   U8PTR_END
        MOVIA   32
        MOVAR   u8count1Tmp
        MOVAR   u8count1
        MOVIA   1
        MOVAR   u8count2

FADE_EN1:
        CALL    FADE_
        RETURN    
 
        
SMOOTH_EN:
        BTRSC   bitFlashLock
        GOTO    SMOOTH_EN1
        BSR     bitFlashLock
        BSR  F_J_D  
        CLRR    U8PTR_SAT
        CLRR    u8ptr
        MOVIA   6
        MOVAR   U8PTR_END
        MOVIA   5
        MOVAR   u8count1Tmp 
        MOVIA   1
        MOVAR   u8count1
        MOVAR   u8count2          
SMOOTH_EN1:
        CALL    FADE_
        RETURN    
 


;;==========================================================
;;     дֽ
;;==========================================================
WRTIE_U8STATUS_TO_EE:
      MOVIA   01H
      MOVAR   EEPROM_ADDRESS 
      MOVR    u8status,A
      MOVAR   EEPROM_WRITEDATA
      BSR     bitWriteEnable
      CLRR    u8step
      RETURN
WRITE_BRIGHT_TO_EE:
      MOVIA   02H
      MOVAR   EEPROM_ADDRESS
      MOVR    u8bright,A
      MOVAR   EEPROM_WRITEDATA
      BSR     bitWriteEnable
      CLRR    u8step
      RETURN

WRITE_SPEED_TO_EE:
      MOVIA   03H
      MOVAR   EEPROM_ADDRESS
      MOVR    u8count2Tmp,A
      MOVAR   EEPROM_WRITEDATA
      BSR     bitWriteEnable
      CLRR    u8step
      RETURN     
      
;;==========================================================
;;     ֽ
;;==========================================================
/*READ_ADJ_VALUE:
      MOVAR   EEPROM_ADDRESS
      CALL    READ_1_BYTE
      MOVR    EEPROM_READDATA,A
      SUBIA   6
      BTRSC   C
      GOTO    $+3
      CLRR    CHECKSUM            ;;1  ޽λ
      RETURN
      MOVR    EEPROM_READDATA,A
      RETURN*/

READ_4BYTES:
      CLRR    EEPROM_ADDRESS
      CALL    READ_1_BYTE
      MOVR    EEPROM_READDATA,A
      MOVAR   CHECKSUM             ;;У

      MOVIA   01H
      MOVAR   EEPROM_ADDRESS
      CALL    READ_1_BYTE

      MOVR    EEPROM_READDATA,A
      SUBIA   20
      BTRSC   C
      GOTO    $+3       ;;1 ޽λ
      CLRR    CHECKSUM  ;;0 нλ
      RETURN
      MOVR    EEPROM_READDATA,A
      MOVAR   u8statusBak
      MOVAR   u8status


       MOVIA   02H
     //  CALL    READ_ADJ_VALUE
       MOVAR   EEPROM_ADDRESS
       CALL    READ_1_BYTE
       MOVR    EEPROM_READDATA,A
       SUBIA   32
       BTRSC   C
       GOTO    $+3          ;;1  ޽λ
       CLRR    CHECKSUM
       RETURN
       MOVR    EEPROM_READDATA,A
       MOVAR   u8bright
      
                                                 ;;SUBAR

      MOVIA   03H
     // CALL    READ_ADJ_VALUE
      MOVAR   EEPROM_ADDRESS
      CALL    READ_1_BYTE
      MOVR    EEPROM_READDATA,A
      SUBIA   45
      BTRSC   C
      GOTO    $+3
      CLRR    CHECKSUM            ;;1  ޽λ
      RETURN
      MOVR    EEPROM_READDATA,A
      MOVAR   u8count2Tmp 
      RETURN  
      
      
     
;;==========================================================  
;;      
;;==========================================================
WAIT_FOR_WRITE:
      CLRR    u8step
      BSR     bitWriteEnable
      CALL    WRITE_1_BYTE
      BTRSC   bitWriteEnable
      GOTO    $-2
      RETURN  
      
WRITE_1_BYTE:
      BTRSS    bitWriteEnable
      RETURN
      MOVR    u8step,A
      BTRSS   Z
      GOTO    sjll
      BSR     FSR,6
      MOVR    EEPROM_ADDRESS,A
      MOVAR   E2PADR
      BSR     E2PBER
      BCR     FSR,6
      BSR     u8step,1
      RETURN
sjll:
      BTRSS   u8step,1
      GOTO    elpp
      BSR     FSR,6
      BTRSC   E2PBER
      GOTO    exit
      CLRR    u8step
      BSR     u8step,2
      GOTO    exit
elpp:
      BTRSS   u8step,2
      GOTO    elqq
      BSR     FSR,6
      MOVR    EEPROM_WRITEDATA,A
      MOVAR   E2PDIN
      BSR     E2PWR
      BCR     FSR,6
      CLRR    u8step
      BSR     u8step,3
      RETURN
elqq:
      BTRSS   u8step,3
      RETURN
      BSR     FSR,6
      BTRSC   E2PWR
      GOTO    exit
      BCR     bitWriteEnable
      CLRR    u8step
exit:
      BCR      FSR,6
      RETURN
;;==========================================================
;;
;;==========================================================
READ_1_BYTE:
      BSR     FSR,6      
      MOVR    EEPROM_ADDRESS,A
      MOVAR   E2PADR 
      BSR     E2PRD
      MOVR    E2PDATA,A
      MOVAR   EEPROM_READDATA
      BCR     FSR,6
      RETURN  

;******************************************************************************************************
;*      :
;*      ܣ˯ģʽ
;*  ڲ
;*  ڲ
;*      ڣ2020.4.1
;*      ߣм
;******************************************************************************************************/
/*SLEEP_CTR:       
        MOVR    u8status,A 
        XORIA   30
        BTRSS   Z 
        RETURN               
        
        CALL    INIT_SYSTEM       

        MOVIA   00000010B
        MOVAR   INTEN
SLEEP_S:
        CLRR    INTFLAG
      ;;  MOVR    PORTB,A
        SLEEP
        NOP
        NOP
        CLRR    u8IrValue
        BCR     bitRealse        
        CALL    DELAY_250US
        CALL    SCAN_IR             
        MOVR    u8IrValue,A   
        XORIA   C_ON
        BTRSC   Z
        GOTO    SLEEP_EXIT           
        BTRSC   bitRealse
        GOTO    SLEEP_S
        GOTO    $-8
SLEEP_EXIT:    
        CLRR    FLAG_BIT
        CLRR    FLAG_LED 
        
        MOVR    u8statusBak,A
        MOVAR   u8status        

        CALL    T0_ENABLE
        RETURN    */
;;==========================================================
;;    ʱʼ
;;==========================================================
T0_ENABLE: 
      ;;  MOVIA   00000000B                  ;;                  TIMER0 RATE   WDT RATE
      ;;  OPTION                             ;; B0   B1   B2      B3            B3
      ;;  BCR     T0IF
        MOVIA   126
        MOVAR   TMR0 
        BCR     T0IF
        BSR     T0IE
        BSR     GIE
        RETURN   
;;==========================================================
;;    ʱ 
;;==========================================================
DELAY_10MS:     
     MOVIA    80
     MOVAR    R11
     MOVIA    82     
     MOVAR    R10
     DECRSZ   R10,R
     GOTO     $-1
     DECRSZ   R11,R
     GOTO     $-5
     RETURN  

DELAY_250US:
    MOVIA   2
    MOVAR   R11
    MOVIA   82
    MOVAR   R10
    DECRSZ  R10,R
    GOTO    $-1
    DECRSZ  R11,R
    GOTO    $-5
    RETURN 
;;==========================================================
;;    INITIALIZE SYSTEM CONFIG
;;==========================================================
INIT_SYSTEM:
    ;;  CLRWDT
    ;;  CLRR    INTEN
     ;; CLRR    INTFLAG
      MOVIA   00001000B                  ;;                  TIMER0 RATE   WDT RATE
      OPTION                             ;; B0   B1   B2      B3            B3


     ;; MOVIA   00000000B
      CLRR   PCON                       ;; B6 EIS     =0,IOB0 IS SELECTED.
                                         ;;            =1,INT IS SELECTED.
                                         ;; B7 WDTE

   ;;   MOVIA   00000000B
   ;;   MOVAR   PORTA
   ;;   MOVIA   00000000B
   ;;   IOST    PORTA

      MOVIA   00001000B
      MOVAR   PORTB
      MOVIA   00001000b
      IOST    PORTB                      ;;0   1

      MOVIA   00001000B                 ;; PORTB INPUT CHANGE INTERRUPT/WAKE_UP CONTROL REGISTER
      MOVAR   WUCON

      MOVIA   11110111B                 ;; PORTB PULL-HIGH CONTROL REGISTER
      MOVAR   PHCON                     ;;0  ʹڲ  1ֹڲ

  ;;    MOVIA   00000000B                 ;; PORTB OPEN-DRAIN CONTROL REGISTER
  ;;    MOVAR   ODCON

  ;;    MOVIA   11111111B                 ;; PULL-DOWN CONTROL REGISTER
  ;;    MOVAR   PDCON                     ;; B6~B4 = IOB2~IOB0
                                        ;; B3~B0 = IOA3~IOA0
      RETURN
      
      
;;==========================================================
;;    HARDWARE INTERRUPT SEGMENT
;;==========================================================
HD_INTERRUPT_ENTER:
        MOVAR   ACC_PROTECT            ;ACC
        SWAPR   STATUS,A               ;״̬Ĵֳ
        MOVAR   STATUS_PROTECT
        SWAPR   FSR,A                  ;BANK
        MOVAR   FSR_PROTECT
        BCR     RP0
         
        MOVIA   126
        MOVAR   TMR0                 
        BCR     T0IF                      
        BSR     bit130us         
        
        DECRSZ  u8260us,R
        GOTO    entern_5ms
        MOVIA   2
        MOVAR   u8260us
        BSR     bit260us   
            
entern_5ms:                 
        DECRSZ  u85ms,R     
        GOTO    INT_EXIT          
         
        MOVIA   42
        MOVAR   u85ms
        BSR     bit5ms  
/*entern_1ms:   
        DECRSZ  u81ms,R                     
        GOTO    INT_EXIT          
                
        MOVIA   4
        MOVAR   u81ms
       ;; BSR     bit1ms
entern_100ms:        
        DECRSZ  u8100ms,R     
        GOTO    INT_EXIT                  
        MOVIA   98
        MOVAR   u8100ms
        BSR     bit100ms */               
INT_EXIT:  
        CLRR    INTFLAG 
        
        SWAPR   FSR_PROTECT,A
        MOVAR   FSR                    ; ָFSR
        SWAPR   STATUS_PROTECT,A
        MOVAR   STATUS                 ; ָ״̬Ĵ
        SWAPR   ACC_PROTECT,R
        SWAPR   ACC_PROTECT,A          ; ָACC
        RETFIE      
      
        ORG     3FFH 
        GOTO    START




